honeybee(1)

# NAME

Make calls on linux using snikket sdk

# SYNOPSIS

To start the call daemon:

*honeybee* [options]

Use *honeyctl* to use the daemon. See _honeyctl_(1).

# CONFIGURATION

Make a config in your `$XDG_CONFIG_HOME/honeybee/config.json`:

```
{
	"username": "test@example.com",
	"password_eval": "gopass -o websites/example.com/test@example.com | tr -d '\n'"
}
```

password_eval's value will be evaluated using your `/bin/sh` shell.
The command's standard output will be your account password.
In this configuration example, our password is encrypted on disk and we use the gopass decrypt our password.
Most password managers will append '\n' to the end of your password when printing to stdout.
If your password does not have a '\n' at the end of your password, remember to trim the '\n' special character using the `tr` command.

## HOOKS

Hooks are user defined scripts that run during certain events
You can assign a hook for "start_call, incoming_call, end_call, online, offline" events.
Hooks are to be placed in `$XDG_CONFIG_HOME/honeybee/`.
If there is a jabber id associated with the hook type, the jabber id will be passed in as the first argument to the script.
Make sure your hooks have the executable bits set.

For example, here is my incoming_call hook at `$XDG_CONFIG_HOME/honeybee/incoming_call`:

```
#!/bin/sh

notify-send "Call from $1"
```

# AUTHORS

- Anjandev Momi <anjan@momi.ca>

# BUGS AND SUPPORT

- For support, please see: https://sr.ht/~anjan/honeybee/

# COPYRIGHT

Honeybee is licensed under the GNU Affero General Public License v3 ONLY.

# SEE ALSO

_honeyctl_(1)
