#define _POSIX_C_SOURCE 1
#include <pulse/simple.h>
#include <stdio.h>
#include "snikket.h"


// TODO: move to pass by reference
static pa_simple *pulse = NULL;
static pa_simple *pulse_rec = NULL;
static pa_sample_spec ss_rec;

// pointer is on heap
// JUST USE C STUPID AND IMPORT INTO ZIG
extern void on_pcm(short *pcm, size_t cpcm, int clock_rate, int channels) {
	if (pulse == NULL) {
		pa_sample_spec ss;
		ss.format = PA_SAMPLE_S16NE;
		ss.channels = channels; // assume these don't change per frame for now
		ss.rate = clock_rate;

		pulse = pa_simple_new(
			NULL,               // Use the default server.
			"Honeybee Caller", // Our application's name.
			PA_STREAM_PLAYBACK,
			NULL,               // Use the default device.
			"Call",             // Description of our stream.
			&ss,                // Our sample format.
			NULL,               // Use default channel map
			NULL,               // Use default buffering attributes.
			NULL                // Ignore error code.
		);
	}

	pa_simple_write(pulse, pcm, cpcm * 2, NULL);
	snikket_release(pcm);
}

// Audio track ready to send more, so let's get from PulseAudio and supply some
extern void on_ready_for_pcm(void *track) {
	if (pulse_rec == NULL) {
		void **formats;
		size_t cformats = snikket_jingle_media_stream_track_supported_audio_formats(track, &formats);
		for (size_t i = 0; i < cformats; i++) {
			if (pulse_rec == NULL) {
				ss_rec.format = PA_SAMPLE_S16NE;
				ss_rec.channels = snikket_jingle_audio_format_channels(formats[i]);
				ss_rec.rate = snikket_jingle_audio_format_clock_rate(formats[i]);

				pa_buffer_attr attr;
				attr.maxlength = -1;
				// Tell pulse that we don't want more than 20ms latency
				attr.fragsize = pa_usec_to_bytes(20000, &ss_rec);

				pulse_rec = pa_simple_new(
					NULL,               // Use the default server.
					"Honeybee Caller",  // Our application's name.
					PA_STREAM_RECORD,
					NULL,               // Use the default device.
					"Call",             // Description of our stream.
					&ss_rec,                // Our sample format.
					NULL,               // Use default channel map
					&attr,
					NULL                // Ignore error code.
				);
			}
			snikket_release(formats[i]);
		}
		snikket_release(formats);
	}

	int samples = (ss_rec.rate / 1000) * 20; // 20 ms
	short pcm[samples];
	pa_simple_read(pulse_rec, &pcm, sizeof(pcm), NULL);
	snikket_jingle_media_stream_track_write_pcm(track, pcm, samples, ss_rec.rate, ss_rec.channels);
}
