const std = @import("std");

pub const SOCK_PORT = 40111;
pub const SOCK_IP = "127.0.0.1";

const SockInfo = struct {
    address: std.net.Address,
    sock: i32,
};

// Get socket info (address and IP) for honeybee
pub fn get_sock_info() SockInfo {
    const adr = std.net.Address.parseIp(SOCK_IP, SOCK_PORT) catch unreachable; // TODO: make this a file
    const sock = std.posix.socket(
        std.posix.AF.INET,
        std.posix.SOCK.DGRAM,
        std.posix.IPPROTO.UDP,
    ) catch unreachable;

    return SockInfo{
        .address = adr,
        .sock = sock,
    };
}
